package me.Demon.DemonBuildShop;

import me.Demon.DemonPlugin.DemonAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;
import org.bukkit.plugin.java.JavaPlugin;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class Main extends JavaPlugin implements Listener {

    public static Main plugin;
    public static String prefix = "§7[§建筑商店§7] §f";
    public static List<Player> LockAccount = new ArrayList<>();

    public void onEnable() {
        plugin = this;
        saveDefaultConfig();
        Bukkit.getPluginManager().registerEvents(this, this);
        Bukkit.getServer().getPluginManager().registerEvents(new gui_1(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new gui_2(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new gui_3(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new gui_4(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new gui_5(), plugin);
        Bukkit.getServer().getPluginManager().registerEvents(new gui_6(), plugin);
        Bukkit.getConsoleSender().sendMessage("§a[建材商城] §f插件成功载入服务器.");
    }

    public void onDisable() {
        Bukkit.getConsoleSender().sendMessage("§c[建材商城] §f插件已经从服务器中卸载.");
    }

    public boolean onCommand(CommandSender sender, Command cmd, String CommandLabel, String[] args) {
        if (CommandLabel.equalsIgnoreCase("buildshop")) {
            if (args.length == 0) {
                gui_1.OpenGui((Player) sender);
            } else if (args.length == 1 && sender.isOp()) {
                if (args[0].equalsIgnoreCase("reload")) {
                    reloadConfig();
                    sender.sendMessage(prefix + "配置文件重载完成。");
                } else {
                    OpenGui((Player) sender, Integer.parseInt(args[0]));
                }
            }
        }
        return false;
    }

    @EventHandler
    public void onclose(InventoryCloseEvent e) {
        Player p = (Player) e.getPlayer();
        if (e.getView().getTitle().contains("创建配置文件#")) {
            int amount = 0;
            String key = e.getView().getTitle().replace("创建配置文件#", "");
            getConfig().set("ItemShop_" + key, null);
            for (int i = 0; i < e.getInventory().getSize(); i++) {
                ItemStack items = e.getInventory().getItem(i);
                if (!DemonAPI.itemIsNull(items)) {
                    getConfig().set("ItemShop_" + key + "." + i + ".price", 4);
                    items.setAmount(64);
                    getConfig().set("ItemShop_" + key + "." + i + ".items", items);
                    saveConfig();
                    amount++;
                }
            }
            p.sendMessage("创建配置物品总计: §a" + amount + "个");
        }
    }

    public static void OpenGui(Player p, int key) {
        Inventory inv = Bukkit.createInventory(null, 54, "创建配置文件#" + key);
        String str = "ItemShop_" + key;
        FileConfiguration yml = Main.plugin.getConfig();
        if (yml.getString(str) != null) {
            for (String slot_key : yml.getConfigurationSection(str).getKeys(false)) {
                ItemStack item = yml.getItemStack(str + "." + slot_key + ".items");
                int slot = Integer.parseInt(slot_key);
                inv.setItem(slot, item);
            }
        }
        p.openInventory(inv);
    }

    public static String getTime(String format) {
        Date date = Calendar.getInstance().getTime();
        SimpleDateFormat datatime = new SimpleDateFormat(format);
        return datatime.format(date);
    }

    public static ItemStack BackBook(String name) {
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

}
