package me.Demon.DemonBuildShop;

import me.Demon.DemonPlugin.DemonAPI;
import me.skymc.taboomenu.TabooMenuAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemFlag;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class gui_2 implements Listener {

    public static String inv_title = "建材商店(第二页)";
    public static String Next_String = "ItemShop_2";
    public static FileConfiguration yml = Main.plugin.getConfig();

    public static void OpenGui(Player p) {
        Inventory inv = Bukkit.createInventory(null, 54, inv_title);
        if (yml.getConfigurationSection(Next_String) != null) {
            for (String slot : yml.getConfigurationSection(Next_String).getKeys(false)) {
                double price = yml.getDouble(Next_String + "." + slot + ".price");
                ItemStack items = yml.getItemStack(Next_String + "." + slot + ".items").clone();
                inv.setItem(Integer.parseInt(slot), shopItems(items, price));
            }
        }
        inv.setItem(45, arrow(Material.ARROW, "§a上一页"));
        inv.setItem(49, Main.BackBook("§a返回菜单"));
        inv.setItem(53, arrow(Material.ARROW, "§a下一页"));
        p.openInventory(inv);
    }

    public static ItemStack shopItems(ItemStack items, double price) {
        ItemStack item = items.clone();
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(DemonAPI.getItemName(item));
        List<String> lore = new ArrayList<>();
        lore.add("§7价格: " + (int) price + "点券");
        lore.add("§7数量: " + item.getAmount() + "个");
        lore.add("§a§l✔§7点击购买");
        meta.setLore(lore);
        meta.addItemFlags(ItemFlag.HIDE_ATTRIBUTES);
        item.setItemMeta(meta);
        return item;
    }

    public static ItemStack arrow(Material material, String name) {
        ItemStack item = new ItemStack(material);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName(name);
        item.setItemMeta(meta);
        return item;
    }

    @EventHandler
    public void onclick(InventoryClickEvent e) {
        Player p = (Player) e.getWhoClicked();
        if (inv_title.equalsIgnoreCase(e.getView().getTitle())) {
            e.setCancelled(true);
            if (e.getRawSlot() == 45) {
                gui_1.OpenGui(p);
                p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
                return;
            }
            if (e.getRawSlot() == 53) {
                gui_3.OpenGui(p);
                p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
                return;
            }
            if (e.getRawSlot() == 49) {
                TabooMenuAPI.openMenu(p, "商城菜单", true);
            }
            if (e.getRawSlot() >= 0 && e.getRawSlot() < 45) {
                ItemStack item = e.getCurrentItem();
                if (!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                    String str = "ItemShop_" + 2 + "." + e.getRawSlot() + ".";
                    p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK, 1, 2);
                    //获取这个物品多少钱
                    int price = yml.getInt(str + "price");
                    if (!DemonAPI.hasPoints(p, price)) {
                        p.sendMessage(Main.prefix + "你需要§d" + price + "§f点券才能操作.");
                        return;
                    }
                    DemonAPI.takePoints(p, price);
                    p.getInventory().addItem(yml.getItemStack(str + "items").clone());
                }
            }
        }
    }
}
